Package net.sf.saxon.option.xom

## Class XOMWriter

- java.lang.Object
- - net.sf.saxon.event.Builder
  - - net.sf.saxon.option.xom.XOMWriter

- All Implemented Interfaces:
    `javax.xml.transform.Result`, `Receiver`

      public class XOMWriter
      extends Builder

  XOMWriter is a Receiver that constructs a XOM document from the stream of events

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.event.Builder

      `AXIOM_TREE, baseURI, config, currentRoot, DOMINO_TREE, JDOM_TREE, JDOM2_TREE, lineNumbering, LINKED_TREE, MUTABLE_LINKED_TREE, namePool, open, pipe, started, systemId, timing, TINY_TREE, TINY_TREE_CONDENSED, uniformBaseURI, UNSPECIFIED_TREE_MODEL, useEventLocation`

    - ### Fields inherited from interface javax.xml.transform.Result

      `PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `XOMWriter​(PipelineConfiguration pipe)` | Create a XOMWriter using the default node factory
    `XOMWriter​(PipelineConfiguration pipe, nu.xom.NodeFactory factory)` | Create a XOMWriter

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `characters​(java.lang.CharSequence chars, Location locationId, int properties)` | Character data.
    `void` | `close()` | End of the document.
    `void` | `comment​(java.lang.CharSequence chars, Location locationId, int properties)` | Handle a comment.
    `void` | `endDocument()` | Notify the end of a document node
    `void` | `endElement()` | End of an element.
    `NodeInfo` | `getCurrentRoot()` | Get the current root node.
    `nu.xom.Document` | `getDocument()` | Get the constructed document node
    `void` | `open()` | Start of the document.
    `void` | `processingInstruction​(java.lang.String target, java.lang.CharSequence data, Location locationId, int properties)` | Handle a processing instruction.
    `void` | `setUnparsedEntity​(java.lang.String name, java.lang.String systemID, java.lang.String publicID)` | Notify an unparsed entity URI.
    `void` | `startDocument​(int properties)` | Start of a document node.
    `void` | `startElement​(NodeName elemName, SchemaType type, AttributeMap attributes, NamespaceMap namespaces, Location location, int properties)` | Start of an element.
    `boolean` | `usesTypeAnnotations()` | Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

    - ### Methods inherited from class net.sf.saxon.event.Builder

      `getBaseURI, getBuilderMonitor, getConfiguration, getPipelineConfiguration, getSystemId, isTiming, isUseEventLocation, reset, setBaseURI, setLineNumbering, setPipelineConfiguration, setSystemId, setTiming, setUseEventLocation`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.event.Receiver

      `append, append, handlesAppend`

- - ### Constructor Detail

    - #### XOMWriter

          public XOMWriter​(PipelineConfiguration pipe)

      Create a XOMWriter using the default node factory
      Parameters:
        `pipe` - the pipeline configuration

    - #### XOMWriter

          public XOMWriter​(PipelineConfiguration pipe,
                           nu.xom.NodeFactory factory)

      Create a XOMWriter
      Parameters:
        `pipe` - the pipeline configuration
        `factory` - the XOM NodeFactory to be used

  - ### Method Detail

    - #### setUnparsedEntity

          public void setUnparsedEntity​(java.lang.String name,
                                        java.lang.String systemID,
                                        java.lang.String publicID)
                                 throws XPathException

      Notify an unparsed entity URI.
      Parameters:
        `name` - The name of the unparsed entity
        `systemID` - The system identifier of the unparsed entity
        `publicID` - The public identifier of the unparsed entity
      Throws:
        `XPathException` - if an error occurs

    - #### open

          public void open()

      Start of the document.
      Specified by:
        `open` in interface `Receiver`
      Overrides:
        `open` in class `Builder`

    - #### close

          public void close()

      End of the document.
      Specified by:
        `close` in interface `Receiver`
      Overrides:
        `close` in class `Builder`

    - #### startDocument

          public void startDocument​(int properties)
                             throws XPathException

      Start of a document node.
      Parameters:
        `properties` -
      Throws:
        `XPathException` - if an error occurs

    - #### endDocument

          public void endDocument()
                           throws XPathException

      Notify the end of a document node
      Throws:
        `XPathException` - if an error occurs

    - #### startElement

          public void startElement​(NodeName elemName,
                                   SchemaType type,
                                   AttributeMap attributes,
                                   NamespaceMap namespaces,
                                   Location location,
                                   int properties)
                            throws XPathException

      Start of an element.
      Parameters:
        `elemName` - the name of the element.
        `type` - the type annotation of the element.
        `attributes` - the attributes of this element
        `namespaces` - the in-scope namespaces of this element: generally this is all the in-scope namespaces, without relying on inheriting namespaces from parent elements
        `location` - an object providing information about the module, line, and column where the node originated
        `properties` - bit-significant properties of the element node. If there are no relevant properties, zero is supplied. The definitions of the bits are in class `ReceiverOption`
      Throws:
        `XPathException` - if an error occurs

    - #### endElement

          public void endElement()
                          throws XPathException

      End of an element.
      Throws:
        `XPathException` - if an error occurs

    - #### characters

          public void characters​(java.lang.CharSequence chars,
                                 Location locationId,
                                 int properties)
                          throws XPathException

      Character data.
      Parameters:
        `chars` - The characters
        `locationId` - provides information such as line number and system ID.
        `properties` - Bit significant value. The following bits are defined:
        DISABLE_ESCAPING
          Disable escaping for this text node
        USE_CDATA
          Output as a CDATA section
      Throws:
        `XPathException` - if an error occurs

    - #### processingInstruction

          public void processingInstruction​(java.lang.String target,
                                            java.lang.CharSequence data,
                                            Location locationId,
                                            int properties)
                                     throws XPathException

      Handle a processing instruction.
      Parameters:
        `target` - The PI name. This must be a legal name (it will not be checked).
        `data` - The data portion of the processing instruction
        `locationId` - provides information such as line number and system ID.
        `properties` - Additional information about the PI.
      Throws:
        `XPathException` - if an error occurs

    - #### comment

          public void comment​(java.lang.CharSequence chars,
                              Location locationId,
                              int properties)
                       throws XPathException

      Handle a comment.
      Parameters:
        `chars` - The content of the comment
        `locationId` - provides information such as line number and system ID.
        `properties` - Additional information about the comment.
      Throws:
        `XPathException` - if an error occurs

    - #### usesTypeAnnotations

          public boolean usesTypeAnnotations()

      Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events
      Specified by:
        `usesTypeAnnotations` in interface `Receiver`
      Overrides:
        `usesTypeAnnotations` in class `Builder`
      Returns:
        true if the Receiver makes any use of this information. If false, the caller may supply untyped nodes instead of supplying the type annotation

    - #### getDocument

          public nu.xom.Document getDocument()

      Get the constructed document node
      Returns:
        the document node of the constructed XOM tree

    - #### getCurrentRoot

          public NodeInfo getCurrentRoot()

      Get the current root node.
      Overrides:
        `getCurrentRoot` in class `Builder`
      Returns:
        a Saxon wrapper around the constructed XOM document node